﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace Cancellation
{
    class Program
    {
        static int PerformSelect(int value)
        {
            Thread.SpinWait(int.MaxValue);
            return value;
        }   

        static CancellationTokenSource cs=new CancellationTokenSource();
        static void Main(string[] args)
        {
            int[] numbers = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
            (new Thread(new ThreadStart(Cancellation))).Start();
            try
            {
                var result = numbers.AsParallel().WithCancellation(cs.Token).Select(number => PerformSelect(number)).ToList();
            }
            catch (OperationCanceledException ex)
            {
                    Console.WriteLine(ex.Message);
            }
            catch (AggregateException ex)
            {
                foreach (var inner in ex.InnerExceptions)
                {
                    Console.WriteLine(inner.Message);
                }
            }

            Console.WriteLine("Press enter to exit");
            Console.ReadLine();
        }

        static void Cancellation()
        {
            Thread.Sleep(4000);
            cs.Cancel();
        }
    }
}
    