﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.Concurrent;
using System.Threading.Tasks;
using System.Threading;

namespace Example
{
    class Person
    {
        static ConcurrentBag<Person> customerList = new ConcurrentBag<Person>();
        public string Name { get; set; }
        public Person() {customerList.Add(this);}
        public void ShopAndExit(){
            var rand=new Random();
            Thread.SpinWait(rand.Next(int.MaxValue));
            Person cust;
            if (customerList.TryTake(out cust))
            {
                if (cust.GetHashCode() == this.GetHashCode())
                {
                    Console.WriteLine("**** {0}=={1} objects are identical ****",
                        cust.Name, this.Name);
                }
            }
        }
    }

    class Program
    {
         static void Main(string[] args)
        {
            Parallel.For(0, 4, (index) =>
            {
                var customer=new Person(){Name="Customer "+
                    index.ToString()};
                Console.WriteLine("[Thread {0}] {1} entering store.", 
                    Thread.CurrentThread.ManagedThreadId, customer.Name);
                customer.ShopAndExit();
                Console.WriteLine("[Thread {0}] {1} leaving store.",
                    Thread.CurrentThread.ManagedThreadId, customer.Name);
            });

            Console.WriteLine("Press enter to exit");
            Console.ReadLine();

        }
    }
} 