﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Collections.Concurrent;

namespace RangePartitioning
{
    class Program
    {
        static int count = 0;

        static void DoSomething()
        {
            int localCount = Interlocked.Increment(ref count);
            Console.WriteLine("Task {0} : Task {1}", 
                Task.CurrentId, localCount);
            Thread.SpinWait(int.MaxValue / 10);
        }

        static void Main(string[] args)
        {

            var methods = new Action[] {   DoSomething, DoSomething, 
                                                DoSomething, DoSomething,
                                                DoSomething, DoSomething, 
                                                DoSomething, DoSomething };

            Parallel.ForEach(Partitioner.Create(0, methods.Length, 2), range=>
            {
                for (int index = range.Item1; index < range.Item2; ++index)
                {
                    methods[index]();
                }
            });

            Console.WriteLine("Press enter to exit");
            Console.ReadLine();
        }
    }
}